#include <stdlib.h>
#include <stdio.h>

#include "Frame.h"

Frame::Frame(float* b, int w, int h, int t, int v) {
  buf = b;
  width = w;
  height = h;
  vpp = v;
  brightness = 0;
  contrast = 0;
  time = t;
}

Frame::Frame() {
  buf = NULL;
  width = 0;
  height = 0;
  vpp = 1;
  brightness = 0;
  contrast = 0;
}

Frame::Frame(int w, int h, int t, int v) {
  width = w;
  height = h;
  vpp = v;
  buf = new float[w * h * v];
  brightness = 0;
  contrast = 0;
  time = t;
}

void Frame::operator =(Frame a) {
  buf = a.buf;
  width = a.width;
  height = a.height;
  time = a.time;
  vpp = a.vpp;
  brightness = a.brightness;
  contrast = a.contrast;
}

float Frame::val(int x, int y, int c) {
  if( x >= 0 && x < width && y >= 0 && y < height ) {
    return buf[((y*width+x) * vpp) + c];
  }
  else {
    return 0.0;
  }
}