#ifndef HANDLE_H

#include <qlabel.h>

#include "vectormath.h"

#ifndef sign
#define sign(x) (x < 0 ? -1 : 1)
#endif

Vector qPtVec(const QPoint p);
QPoint vecQPt(const Vector v);


class Handle : public QLabel {
  Q_OBJECT
  public:
    Handle( QWidget*, QPaintDevice* );
    Handle( QWidget*, QPaintDevice*, int id );
    void setPos( const QPoint );
    void setId(int);
    void setAngle(float a);
    QPoint center();
    void drawWidget(QPaintDevice*);
    void setPaintDevice(QPaintDevice*);

  signals:
    void posChanged(int);

  protected:
    void mouseMoveEvent ( QMouseEvent * e );
    void mousePressEvent ( QMouseEvent * e );
    void paintEvent( QPaintEvent * );

  private:
    void init();
    int id;
    float angle;
    QPaintDevice *paintDevice;
    QPoint pressMousePos;
};

#define HANDLE_H
#endif
