#ifndef PLOTTHREAD_H

#include <qthread.h>

#include "Frame.h"
#include "RectRegion.h"
#include "GLPlot.h"

class PlotThread : public QThread {
  public:
    PlotThread(GLPlot*);
    void run();
    void stop();
    Frame swapNewFrame(Frame);
    void setRegion(RectRegion);
    void setDownsample(int);
    
  private:
    bool running;
    GLPlot* plotWidget;

    QMutex frameMutex;
    Frame nextFrame, currentFrame;
    bool claimNextFrame();

    RectRegion nextRegion, currentRegion;
    bool nextRegionReady;
    QMutex regionMutex;
    bool readNewRegion();
    
    Frame makeFrame();
    bool interpolate;
    int downsample;
};

#define PLOTTHREAD_H
#endif
