/***************************************************************************
 *   Copyright (C) 2005                                                    *
 *   Luke Campagnola                                                       *
 *   Colorado School of Mines                                              *
 *   lcampagn@mines.edu                                                    *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef DLGPROPERTIES_H
#define DLGPROPERTIES_H

#include "dlgmainview.h"
#include "_DlgProperties.h"

#include "uEye.h"


#include <qslider.h>
#include <qlineedit.h>
#include <qspinbox.h>
#include <qstring.h>
#include <qlabel.h>
#include <qcheckbox.h>
#include <qbuttongroup.h> 

class DlgProperties : public _DlgProperties
{
  Q_OBJECT

public:
  DlgProperties(HIDS hCam, CAMINFO camInfo, SENSORINFO sensorInfo, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
  ~DlgProperties();
  /*$PUBLIC_FUNCTIONS$*/

public slots:
  /*$PUBLIC_SLOTS$*/
  virtual void          OnSpinBoxSizeChanged(int value);
  virtual void          OnSpinBoxPosChanged(int value);
  virtual void          OnRadioWhiteBalance();
  virtual void          OnRadioEdgeEnhancement();
  virtual void          OnButtonBadPixel();
  virtual void          OnButtonEnableColorCor();
  virtual void          OnButtonUpDown();
  virtual void          OnSliderChangeFrameRate(int value);
  virtual void          OnSliderChangeExposure(int value);
  virtual void          OnSliderChangePixelClock(int value);
  virtual void          OnSliderChangeBlue(int value);
  virtual void          OnSliderChangeGreen(int value);
  virtual void          OnSliderChangeRed(int value);
  virtual void          OnSliderChangeMaster(int value);
  virtual void          OnButtonDefault();
  virtual void          OnSliderChangeGamma(int value);
  virtual void          OnSliderChangeCont(int value);
  virtual void          OnSliderChangeBright(int value);
  
  
protected:
  /*$PROTECTED_FUNCTIONS$*/
	void showEvent ( QShowEvent * );  

protected slots:
  /*$PROTECTED_SLOTS$*/
   
public:

private:
	// Camera Handle
	HIDS m_hCamera;
	// Camerainfo
	CAMINFO m_CamInfo;
	// SensorInfo
	SENSORINFO m_SensorInfo;
	
	// Update Framerate controls
	void UpdateFramerate();
	// Update Exposure controls
	void UpdateExposure();
	// Update window size controls
	void UpdateWindowSizeCtrls();
	
	// min und max pixelclock
	BOOL m_bInit;
	int m_maxPclk;
	DlgMainView* m_pDlgMainView;

};

#endif












