#ifndef max
#define max(a, b) ((a > b) ? a : b)
#endif

#ifndef min
#define min(a, b) ((a < b) ? a : b)
#endif

#include <stdio.h>

float* arrayMid(float* data, int num, int radius) {
  int start = 0;
  int stop = 0;
  float* mid = new float[num];
  for( int i=0; i<num; i++ ) {
    start = max(0, i-radius);
    stop = min(i+radius, num-1);
    mid[i] = 0.0;
    float mx, mn;
    mx = mn = data[start];
    for( int j=start; j<=stop; j++ ) {
      mx = max(mx, data[j]);
      mn = min(mn, data[j]);
    }
    mid[i] = (mx+mn) / 2.0;
/*    fprintf(stderr, "#%d: start %d stop %d mid %f\n", i, start, stop, mid[i]);*/
  }
  return mid;
}

void calcPlotCrossing(float* plot, float* trigger, int width, float** ticks, int* numTicks) {
  float* t = new float[5000]; // should be doing some dynamic memory allocation, but I'm lazy.
  int num = 0;
  for( int i=0; i<width-1; i++ ) {
    if( plot[i] > trigger[i] && plot[i+1] < trigger[i+1] ) {
      float y1 = plot[i]-trigger[i];
      float y2 = trigger[i+1]-plot[i+1];
      float d = y1/(y1+y2);
      t[num] = (float)i + d;
      num++;
    }
  }
  *ticks = t;
  *numTicks = num;
}
